﻿local ADDONNAME, TrapSenseData = ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")
TrapSenseData.Functions = {}
local TrapSense = TrapSenseData.Functions;
local _;

--[SVARS]Saved Variables, Per Character
local defaults  = {}
-- LOCAL Variables
-- Text Color Constants
local White  				= "|cffffffff";
local Red    				= "|cffff0000";
local Green  				= "|cff00ff00";
local Blue   				= "|cff6060ff";
local Cyan   				= "|cff00ffff";
local Magenta				= "|cffff00ff";
local Yellow 				= "|cffffff00";

-- Bar State Colors

local LinkTemplate 			= "\124cffffd000\124Henchant:SPELL\124h[SKILL: NAME]\124h\124r"
local FrameUI 				= {};
local PetList = {}
local PetListSize = 0;
local BattlePetTypeNames = {
		[01] = "Humanoid",
		[02] = "Dragonkin",
		[03] = "Flying",
		[04] = "Undead",
		[05] = "Critter",
		[06] = "Magic",
		[07] = "Elemental",
		[08] = "Beast",
		[09] = "Aquatic",
		[10] = "Mechanical"
}
local RarityInfo = {
		[1] = {Desc = "Poor", 		Color = "|cff879d8a"},
		[2] = {Desc = "Common", 	Color = "|cffffffff"},
		[3] = {Desc = "Uncommon", 	Color = "|cff00ff00"},
		[4] = {Desc = "Rare" 		Color = "|cff006edc"}
}
-- Slash Commands
SLASH_TrapSense1 = "/trap";	-- /Commands

--[[INITIALIZERS]]--
--[PLOAD] Loading Action
function TrapSense_OnLoad(self)
	self:SetBackdropBorderColor(TOOLTIP_DEFAULT_COLOR.r, TOOLTIP_DEFAULT_COLOR.g, TOOLTIP_DEFAULT_COLOR.b);
	self:SetBackdropColor(TOOLTIP_DEFAULT_BACKGROUND_COLOR.r, TOOLTIP_DEFAULT_BACKGROUND_COLOR.g, TOOLTIP_DEFAULT_BACKGROUND_COLOR.b);
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_ENTERS_WORLD");
	self:RegisterEvent("CHAT_MSG_SYSTEM");
end

--[EVENT] Event Handler
function TrapSense_OnEvent(self, event, ...)
	-- Starts the addon
	if (event == "ADDON_LOADED") then
		if (...) == ADDONNAME then
			DEFAULT_CHAT_FRAME:AddMessage(Green..ADDONNAME.." "..Red..VERSION..Green..": Loaded. Type "..Cyan..SLASH_TrapSense1..Green.." for help.");
			if( not _G.IsAddOnLoaded("Blizzard_PetJournal") ) then
				_G.LoadAddOn("Blizzard_PetJournal");
			end
			TrapSense.LoadPets()
		end
	elseif (event == "PLAYER_ENTERS_WORLD") then
		
	elseif (event == "CHAT_MSG_SYSTEM") then
		TrapSense.AcquirePet();
	end
end

function SlashCmdList.TrapSense(msg)
	if (msg == 'run') then
		ChatFrame3:AddMessage("--")
		for i = 16,17 do
			--#, #, bool, nil, #, bool, bool, name, icon, #, #, tooltip, bool, bool, bool, bool = C_PetJournal.GetPetInfoByIndex(index)
			local PetID, CompanionID, IsOwned, NickName, Level, IsFavorite, var1, Species, IconTexture, PetType, NPCID, AcqMethod, FlavorText, var2, var3, var4, var5 = C_PetJournal.GetPetInfoByIndex(i)
			print(PetID)
			print(CompanionID)
			print(IsOwned)
			print(NickName)
			print(Level)
			print(IsFavorite)
			print(var1)
			print(Species)
			print(IconTexture)
			print(PetType)
			print(NPCID)
			print(AcqMethod)
			print(FlavorText)
			print(var2)
			print(var3)
			print(var4)
			print(var5)
		end
	end
end

function TrapSense.LoadPets()
	local Journal = C_PetJournal;
	Journal.ClearSearchFilter();
	Journal.AddAllPetTypesFilter()
	Journal.AddAllPetSourcesFilter()
	PetList = {}
	for i = 1, 500 do
		local PID, sID, owned, Nick, Lv, fav, _, spec, tex, cat = C_PetJournal.GetPetInfoByIndex(i)
		if (not owned) then break end;
		table.insert(PetList, {PetID = PID, SpeciesID = sID, IsOwned = owned, NickName = Nick, Level = Lv, IsFavorite = fav, SpeciesName = spec, IconTexture = tex, PetType = cat})
		PetListSize = i;
	end
	print("List Loaded")
end
function TrapSense.AcquirePet(msg)
	if(string.find(msg, ("added to pet journal")) == nil) then return end;
	print("I see it.")
end

function TrapSense.Hook(self)
	local name, unit = self:GetUnit()
	if(not UnitIsWildBattlePet(unit)) then return end; --if Tooltip for non BattlePet, ignore
	local Owned = TrapSense.SpeciesMatch(name);
	if(Owned[1] ~= 0) then
		self:AddLine("Owned:");
		for i = 1, 3 do	--List owned versions of the species
			local PetID,_,_, nick, lv = C_PetJournal.GetPetInfoByIndex(Owned[i])
			local _,_,_,_, petrarity = C_PetJournal.GetPetStats(PetID)
			if (nick ~= nil) then
				name = nick.."("..name..")" --add nickname if has one
			end
			self:AddLine(name..", Lv"..lv.."("..RarityInfo[petrarity].color..RarityInfo[petrarity].Desc.."|r)")
		end
	else
		self:AddLine("|cff0000ffNone Owned."); --if none owned
	end
	if(Owned[3] ~= 0) then --if unable to catch more.
		self:AddLine("|cffff0000"..name.." Cages Full.")
	end
end

function TrapSense.SpeciesMatch(Species)
	local Owned = {[1] = 0, [2] = 0, [3] = 0} --tracker for index hits
	local counter = 0;
	for i = 1, PetListSize do --fill index list with indicies of matches
		if (PetList[i].SpeciesName == name) then
			counter = counter + 1;
			Owned[counter] = i;
		end
		if (counter == 3) then break end; --Limited 3 of any species
	end
	return Owned;
end

_G[ADDONNAME] = TrapSense;
GameTooltip:HookScript("OnTooltipSetUnit", TrapSense.Hook);